<template>
  <div>
    <p class="font-weight-bold text-center">Pie Chart component</p>
    <div class="d-flex justify-center mb-16">
      <template>
        <v-card style="box-shadow: none">
          <v-toolbar style="box-shadow: none">
            <!--      Tabs -->
            <template>
              <v-tabs v-model="tabSelected" centered @change="tabClick()">
                <v-tab v-for="(item, i) in tabs" :key="i">
                  {{ item }}
                </v-tab>
              </v-tabs>
            </template>
          </v-toolbar>

          <v-tabs-items v-model="tabSelected">
            <!--            Pie Chart of Impressions -->
            <v-tab-item>
              <v-card style="box-shadow: none">
                <v-card-text>
                  <apexchart  v-if="!loading" width="500" type="donut" :options="options" :series="series"></apexchart>
                </v-card-text>
              </v-card>
            </v-tab-item>
            <!--            Pie Chart of Networks -->
            <v-tab-item>
              <v-card style="box-shadow: none">
                <v-card-text>
                  <apexchart v-if="!loading" width="500" type="donut" :options="options" :series="series"></apexchart>
                </v-card-text>
              </v-card>
            </v-tab-item>
          </v-tabs-items>
        </v-card>
      </template>
    </div>
  </div>
</template>

<script>
// Import Vue Apexcharts Component
import chart from 'vue-apexcharts'

export default {
  name: 'PieChart',
  components: {
    apexchart: chart
  },
  props: {
    posts: [Array, Object]
  },
  data () {
    return {
      loading: true,
      // Apexcharts Options
      tabs: ['Impressions', 'Networks'],
      tabSelected: null,
      series: [],
      chart: {
        id: 'impressions',
        group: 'social',
        type: 'area',
      },
      options: {
        dataLabels: {
          enabled: false,
        },
        // Enable % Symbol to
        legend: {
          formatter: function (val, opts) {
            return val + ' - ' + opts.w.globals.series[opts.seriesIndex] + '%'
          }
        }
      },

      // Pie Chart Tabs
      text: '',
    }
  },
  methods: {
    tabClick () {
      this.loading = true
      this.series = []
      this.options.labels = []

      if (this.tabSelected === 0) {
        // Impressions
        let types = this.posts.reduce((r, o) => {
          if (!r[o.type]) {
            r[o.type] = { ...o }
          } else {
            r[o.type].impressions += +o.impressions
          }
          return r
        }, {})

        // Calculate a % of Impressions
        let sum = Object.values(types).reduce(function (sum, value) {
          return sum + value.impressions
        }, 0)
        Object.values(types).forEach(value => {
          this.series.push(~~(100 * value.impressions / sum))
          this.options.labels.push(value.type.charAt(0).toUpperCase() + value.type.slice(1))
        })
      } else {
        // Networks
        let types = this.posts.reduce((r, o) => {
          if (!r[o.network]) {
            r[o.network] = { ...o }
          } else {
            r[o.network].impressions += +o.impressions
          }
          return r
        }, {})

        // Calculate a % of Impressions
        let sum = Object.values(types).reduce(function (sum, value) {
          return sum + value.impressions
        }, 0)
        Object.values(types).forEach(value => {
          this.series.push(~~(100 * value.impressions / sum))
          this.options.labels.push(value.network.charAt(0).toUpperCase() + value.network.slice(1))
        })
      }

      setTimeout(() => {
        this.loading = false
      }, 200)
    },
  },
  created () {}
}
</script>
